import java.util.ArrayList;

/**
 * Lab #6 
 * CS 2334, Section SECTION NUMBER GOES HERE
 * DATE GOES HERE
 * <p>
 * Each object of this class represents a place.
 * </p>
 * @version 1.0
 *
 */
public class Place {
	private String name;
	private String state;
	private ArrayList<PopulationRecord> historicalRecords = new ArrayList<PopulationRecord>(); 
	
	/**
	 * @param name
	 * @param population
	 * @param year
	 */
	public Place(String name, String state, String population, String year) {
		this.setName(name);
		this.setState(state);
		this.historicalRecords.add(new PopulationRecord(year, population));
	}

	/**
	 * @return the name of the place
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param name the name to set as the place name
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @return the state
	 */
	public String getState() {
		return state;
	}
	
	/**
	 * @param state the state to set
	 */
	public void setState(String state) {
		this.state = state;
	}

	/**
	 * @return the historical record for a place
	 */
	public ArrayList<PopulationRecord> getHistory() {
		return this.historicalRecords;
	}

	/**
	 * @param populationRecord the new yearly population record to add to the place's history
	 */
	public void addToHistory(PopulationRecord populationRecord) {
		historicalRecords.add(populationRecord);
	}
	/**
	 * @return the place as a String
	 */
	public String toString() {
		return name + ", " + state + " " + historicalRecords;
	}
}
