import java.util.LinkedHashMap;

/**
 * Lab #6 
 * CS 2334, Section SECTION NUMBER GOES HERE
 * DATE GOES HERE
 * <p>
 * Each object of this class represents a list of places.
 * Note that for this lab we are assuming each place has a unique name.
 * </p>
 * @version 1.0
 *
 */
public class Places {
	// TODO:  Make this class serializable

	private String country;
	private LinkedHashMap<String, Place> placeMap;

	/**
	 * no arg constructor
	 */
	public Places (){
		this.country = "";
		this.placeMap = new LinkedHashMap<String, Place>();
	}
	
	/**
	 * constructor that takes a country value
	 * @param country
	 */
	public Places (String country) {
		this.country = country;
		this.placeMap = new LinkedHashMap<String, Place>();
	}

	/**
	 * constructor that takes a country value plus an existing LinkedHashMap of places
	 * @param country
	 * @param placeMap
	 */
	public Places(String country, LinkedHashMap<String, Place> placeMap) {
		this.country = country;
		this.placeMap = placeMap;
	}

	/**
	 * @return the country
	 */
	public String getCountry() {
		return country;
	}

	/**
	 * @param country the country to set
	 */
	public void setCountry(String country) {
		this.country = country;
	}

	/**
	 * @return the placeMap
	 */
	public LinkedHashMap<String, Place> getPlaceMap() {
		return placeMap;
	}

	/**
	 * @param placeMap the collection of places to set
	 */
	public void setPlaceMap(LinkedHashMap<String, Place> placeMap) {
		this.placeMap = placeMap;
	}
	
	/**
	 * @param name the name of the place to look for in the collection
	 * @return true if the place name is already in the collection, false otherwise
	 */
	public boolean contains(String name) {
		return this.placeMap.containsKey(name);
	}
	
	/**
	 * @param name the name of the place to look for in the collection
	 * @return the found place converted to a String
	 */
	public String getPlaceString(String name) {
		return this.placeMap.get(name).toString();
	}
		
	/**
	 * @param place to add to the placeMap
	 */
	public void addToPlaces(Place place) {
		this.placeMap.put(place.getName(), place);
	}
	
	/**
	 * @param place the place to replace in the placeMap
	 */
	public void replaceInPlaceMap(Place place) {
		this.placeMap.put(place.getName(), place);
	}
	
	/**
	 * @param name the name of the place to which to add a new yearly data record
	 * @param newRecord the new yearly population record to add to the place
	 */
	public void addToHistoricalRecord(String name, PopulationRecord newRecord) {
		this.placeMap.get(name).addToHistory(newRecord);
	}
	
	/**
	 * Clears the collection of places
	 */
	public void clearPlaces() {
		this.placeMap = new LinkedHashMap<String, Place>();
	}
	
	// TODO:  Add methods for object input and output
	// These should save the entire Places object
	// Model this after the object IO routines of Lab #4
	// "Hard code" the name of the data file for this to be "Places.dat"
	
	// TODO:  Add method for printing to the console
	// This should print all data of the Places object to the console
	// The formatting is up to you but should be intuitive to the grader
}