import java.awt.event.*;

/**
 * Lab #6 
 * CS 2334, Section SECTION NUMBER GOES HERE
 * DATE GOES HERE
 * <p>
 * The MVC controller for the program.
 * </p>
 * @version 1.0
 */
public class PlacesController {
	private PlacesModel model;
	private PlacesInputWindow inputView;

	/**
	 * Creates new PlacesController
	 */
	public PlacesController() {
		// intentionally empty
	}
	
	/**
	 * @param model to set as the model
	 */
	public void setModel(PlacesModel model) {
		this.model = model;
	}

	/**
	 * @return PlacesModel the model
	 */
	public PlacesModel getModel() { // future use
		return this.model;
	}

	/**
	 * AddPlaceListener provides a method to create a new place. The place
	 * should then be added to the place list of the model. The values for the
	 * new place come from the fields of the inputView. If the model is null
	 * when the method is called, it returns without taking any action.
	 */
	private class AddPlaceListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			if (model == null) return;  // No model associated.  Can't do anything.

			String name = inputView.jtfName.getText();
			String state = inputView.jtfState.getText();
			String population = inputView.jtfPopulation.getText();

			if (model.contains(name)) {  // Place already in collection so ask what to do

				// TODO: Use a JOptionPane here to ask what to do 
				int response;  // assign returned value of JOptionPane to response

				if (response == 0) {
					// option 0 is cancel so do nothing
				}
				else if (response == 1) {
					// TODO: call mutator method to replace place (note that option 1 should be replace)
				}
				else if (response == 2) {
					// TODO: call mutator method to add record to place's history (option 2 should be add to history)
				}
				else {
					// Should handle error case here (we won't for this lab).
				}
			}
			else {  // Place not in collection, so add
			}
		}
	}

	/**
	 * ClearPlacesListener provides a method to clear the place list of the
	 * model. If the model is null when the method is called, it returns without
	 * taking any action.
	 */
	private class ClearPlacesListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			if (model == null) return;  // No model associated.  Can't do anything.
			model.clearPlaces();
		}
	}

	/**
	 * ClearInputFieldsListener provides a method to clear the input fields of
	 * the inputView.
	 */
	private class ClearInputFieldsListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			inputView.clearInputFields();
		}
	}
	
	// TODO:  Create additional listener classes for menu and toolbar.


	/**
	 * @param theView
	 *            on which the listeners should be set
	 */
	public void setInputWindow(PlacesInputWindow theView) {
		inputView = theView;
		
		this.inputView.getAddPlaceButton().addActionListener(new AddPlaceListener());
		this.inputView.getClearInputButton().addActionListener(new ClearInputFieldsListener());
		this.inputView.getClearPlacesButton().addActionListener(new ClearPlacesListener());

		// TODO: Register additional listeners for menu and toolbar.

	}

	/**
	 * @return the window (in case it needs to be sent messages from elsewhere)
	 */
	public PlacesInputWindow getInputWindow() { // future use
		return inputView;
	}
}